
// rev 23/08/2023 version IVT interrupt


// rev 21/08/2023 ..bug sur sortie terminal avec V.O. ??? 
// modif : Hardware init et supprime activation Watchdog?
// 6 poussoirs sur B6,B5,B4,B3,B2,B1 relis via un OU (  diodes) sur entree INT0 RB0
// 18/07/2023  VO SATINAS Fantaspic
// 18F27K42 INT0 et IOC  
// led sur A3 
// 3 poussoirs sur B3,B2,B1 et B0 INT0

#include <xc.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdbool.h>

#include "Config.c"

#define USE_ISR_INT 1                   // use interrupt INT0
#define USE_ISR_IOC 0                   // use interrupt IOC

#define FOSC        64000000            // Fosc=64MHz
#define _XTAL_FREQ  FOSC
#define FCY         (FOSC/4)            // Fcy=16MHz, Tcy=62,5ns
#define BR          115200
#define BRG         ((FCY/BR)-1)        // 138  avec brgs=1   


//------------------------------------------------------
#define VERSION "2028-0823"
// Rajout BP 4,5,6  , mesure de duree appui avec SMT1, et decodage actions
//#define VERSION "V.O  2028-0717 Sanitas"

#define Alarm1  LATBbits.LB7
#define Alarm1_Dir  TRISBbits.TRISB7

#define BP_Egalisation PORTCbits.RC5  
#define BP_Egalisation_Dir TRISCbits.TRISC5  

#define Def_Pins_PORTA  0b00000000   // 3xDS18B20 + leds + relay bruleur
#define Def_Pins_PORTB  0b11111111   // 5 B.P.
#define Def_Pins_PORTC  0b10100111   // output : UART1 TX ,et  I2C SCL,SDA open collector, BP SW6 input

#define  RTC_Forcee   PORTBbits.RB7


#define CR 13
#define LF 10
#define TAB 9
#define UART1_RX_BUFFER_SIZE 128 

#define Directory "C:\\MPLABX_Projects\\18F27K42_test_INT0_IOCBF_6BP_Uart1_2023-08"
#define Project  " Test_Paul"
#define Source   " main_test_INT0_IOCBF_6BP_AVEC_IVT_2023-0823 "
#define Annexe   " XC8 V2.36 C99  Pack: PIC18F-K_DFP 1.6.125"
#define Others   " UART1_Functions.h et *.c " 
#define Eeprom   " No "
#define Hardware " Base 18F27K42 "
#define Config   " Internal Fosc 64MHz"


  const  char Msg0[]=" \r\n PIC18F27K42 + Test interrupt INT0 sur 6 BP portB\r\n";
  const  char Msg1[]=" Directory :"Directory"\r\n";
  const  char Msg2[]=" Project : "Project"\r\n";
  const  char Msg3[]=" Source : "Source"_"VERSION"\r\n";
  const  char Msg4[]=" Config "Config"\r\n";
  const  char Msg5[]=" Autres : "Others"\r\n";
  const  char Msg6[]=" Eeprom :"Eeprom"\r\n";
  const  char Msg7[]=" RA4=led,RA3=SQA,RC6=TX UART1 RC7=RX UART\r\n";
  const  char Msg8[]=" BP SW..SW5 -> OU  diodes-> RV0 INT0 , IOCBF \r\n";
  const  char Msg9[]="....";
  const  char * Messages[]={Msg0,Msg1,Msg2,Msg3,Msg4,Msg5,Msg6,Msg7,Msg8,Msg9};
  const  char Blancs[]="  ";
  
  const char Switches[6][6]={" SW0 "," SW1 "," SW2 "," SW3 "," SW4 "," SW5 "};

unsigned int  i,j,k,l,m,n;
unsigned char  c1,c2,c3,cx,cc;
volatile unsigned char Buffer1[UART1_RX_BUFFER_SIZE];
volatile unsigned int Index1,i1;
volatile unsigned char Flag_Buffer1=0;
unsigned char TEXTE [128];
unsigned char * txt;
volatile char Bavard=0;
unsigned int Nb_Boucles=0;

unsigned char * p0;
unsigned char * p1;
unsigned char * px;
unsigned char CRam1[80];

char Delay_de_Boucle=1;

volatile struct Anybits {   // 8 flags
       unsigned  Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned  Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned  Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned  Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned  Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned  Tmr6_Elapsed:1;     // for timer6 8bits
       unsigned  NCO_initialise:1;   // for NCO
       unsigned  Key_ON :1;          // detection appui BP
 }Drapeaux ;
 
 unsigned long SMT1_Measure __at (0x0020);
unsigned  char *ST;
unsigned long  L1=0;
unsigned long  L2=0;

   
unsigned char Poids[8]={1,2,4,8,16,32,64,128};


volatile unsigned char Etats_BP;
volatile unsigned char Etats_IOCBF;
volatile unsigned  int Count_RB0=0;
unsigned int Duree_Appui=0;

// --- MENU PRINCIPAL ------
volatile unsigned char Menu=0;
volatile unsigned char MPas=0;
// ---- SOUS Menus --------
volatile unsigned char SMenu=0;
volatile unsigned char SPas=0;


bool Status_GIE_Bit;


void __delay_xSec(unsigned char N); 
void delay_X_ms(unsigned int n);
void SMT1_Init(void); // clock 500Khz

#include "UART1_Functions.h"



void  Interrupt_Init(void)
{
    INTCON0bits.IPEN = 1;
    bool state = (unsigned char)  INTCON0bits.GIE;
    INTCON0bits.GIEH = 0; // dishigh priority interrupts
    INTCON0bits.GIEL = 0; // dis low priority interrupts
    INTCON0bits.IPEN = 1; // Enable interrupt priority
   //  __asm("BCF INTCON0,GIE");
   // GIE = 0;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x00; // unlock IVT
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x01; // lock IVT
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
    IPR1bits.INT0IP = 1;
    IPR4bits.TMR1IP = 0;
    IPR3bits.TMR0IP = 0;
    IPR4bits.TMR2IP = 1;
    IPR7bits.TMR4IP = 0;
    IPR9bits.TMR6IP = 0;
    IPR0bits.IOCIP =  0;
    INTCON0bits.GIE= state;
}



void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
  //  U1TXB='H';  // pour debugging only
  if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  {   
      c1=U1RXB;
   //   U1TXB='*'; // echo
     if ((c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
     { 
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0; 
     PIE3bits.U1RXIE =0;
     }
     else
     {
       Buffer1[i1]=c1;
       i1++;
       Index1=i1;
      } 
   } 
}

void __interrupt(irq(IRQ_INT0),high_priority) INT0_ISR(void)
//#if USE_ISR_INT
//void __interrupt(high_priority) highIsr(void)
{
  if (INT0IF)
  {
    unsigned char  p;
    int i;
    __delay_ms(50);
    p = IOCBF>>1; 
    
    delay_X_ms(5);
    //for (i=0; i<8; i++) {
    //  PrintChar(p&0x80 ? '1' : '-');
    //  p <<= 1 ;
    //}
    // PrintChar(13);  PrintChar(10);
 
    SMT1_Measure=0;
    ST=&SMT1_Measure;
    SMT1STATbits.SMT1RST=1;
    SMT1CON1bits.SMT1GO=1;
    k=0;  
    while(PORTB !=0x7F)
    {  __delay_us(100);
      k++;
      if (k>50000) break;
    }    
    Drapeaux.Key_ON=1;
    
    SMT1CON1bits.SMT1GO=0;
    *(ST)=SMT1TMRL;
    *(ST+1)=SMT1TMRH;
    *(ST+2)=SMT1TMRU;
    *(ST+3)=0;
    L1=SMT1_Measure; 
    L2=L1<<1;   
    Duree_Appui=L2/1000; // en mS
      
    Etats_BP=p;
      if ( (Etats_BP==1)  &&( Duree_Appui<1000) )
        {
                if (Menu==0) 
                {
                 Menu=10;
                 SMenu=0;
                 SPas=0;
                }
             MPas++;    
        }
       else 
       {
         if ((Menu!=10) && ( Duree_Appui<5000) ) 
         {    
         if((Etats_BP==2) && ( Duree_Appui>1000) ) Menu=1; // SW1  mode Cf ou EC
         if((Etats_BP==4) && ( Duree_Appui>1000) ) Menu=2;  // SW2  incr consigne
         if((Etats_BP==8) && ( Duree_Appui>1000) ) Menu=3;  //  SW3 dec consigne 
         if((Etats_BP==6)  && ( Duree_Appui>1000)) Menu=6 ;// SW1+SW2  bascule consigne Hors gel ou Normal
         if((Etats_BP==10) && ( Duree_Appui>1000)) Menu=7; // SW1+SW3
         if((Etats_BP==16) && ( Duree_Appui>1000)) Menu=4;    // SW4
         if((Etats_BP==32) && ( Duree_Appui>1000)) Menu=5; // SW5
         }
        }
    IOCBF  = 0x00;
    INT0IF = 0;
  }
}
//#endif

void __delay_xSec(unsigned char N)
{
static int i2;  
for (i2=0;i2<N;i2++)  __delay_ms(1000);
}

void SMT1_Init(void)
{ 
   //04-04-2021
     // registre  SMT1CON0
     SMT1CON0bits.SMT1EN =1;    // SMT enabled
     SMT1CON0bits.WPOL=0; // Window Polarity
     SMT1CON0bits.SPOL=0; // Signal Polarity
     SMT1CON0bits.CPOL=0; // Clock Polarity
     SMT1CON0bits.SMT1PS1=0; // PS<1:0>: SMT Prescale Select bits = 1/1
     SMT1CON0bits.SMT1PS0=0;    // 11=1/8  10=1/4  01=1/2 00=1/1
     SMT1CON0bits.SMT1EN =1;    // SMT enabled
     SMT1CON0bits.SMT1STP=0;    // 0 =reset 1=STOP; 
     SMT1CON1bits.SMT1GO=0;     // 1= suit l'entree   0=stop suivi
     SMT1CON1bits.SMT1REPEAT=0; // 0= Single  Acquisition   1=repeat mode
    // REGISTER 25-4: SMT1CLK: SMT CLOCK SELECTION REGISTER 16MHz
    // 000=FOSC/4    001=FOSC  010=HINTOSC 16MHz    101 = MFINTOSC/16 (32 kHz)
    SMT1CLKbits.CSEL2=  1;   //100 = MFINTOSC (500 kHz)
    SMT1CLKbits.CSEL1=  0;
    SMT1CLKbits.CSEL0=  0;
	// 25.7.1 PW (Pulse Width) AND PR (Periode Read)  ACQUISITIONI NTERRUPTS
      PIR1bits.SMT1PRAIF=0;
      PIE1bits.SMT1PRAIE=0;
     //  25.7.2  PERIOD MATCHI NTERRUPT
      PIR1bits.SMT1IF=0;
      PIE1bits.SMT1IE=0;
      // init  compteur
      SMT1PRU=0xFF;
      SMT1PRH=0xFF;
      SMT1PRL=0xFF;
     // MODE de fonctionnement TIMER  page 396  
     //   0000=Timer   0100=windowed measure  1000=counter
     //SMT1CON1=0;
     SMT1CON1bits.MODE3=0;
     SMT1CON1bits.MODE2=0;
     SMT1CON1bits.MODE1=0;
     SMT1CON1bits.MODE0=0;
     SMT1CON0bits.SMT1EN =1;    // SMT enabled
  //   SMT1_Measure=0L;
  //   ST=&SMT1_Measure; // pointeur Byte sur debut entier long 32 bits

  }

void Hardware_Init(void)
{
    LATA = 0x00;
    LATB = 0xFF;
    LATC = 0x00;
    
    TRISA = 0x00;   // Def_Pins_PORTA;  //0x00
    TRISB = 0xFF;
    Alarm1_Dir=0; //  TRISBbits.TRISB7
    Alarm1=0;
    
    TRISC = Def_Pins_PORTC ; //0xA3 .. confirmer
    BP_Egalisation_Dir=1;   //PORTCbits.RC5        

    ANSELC = 0x00;
    ANSELB = 0x00;
    ANSELA = 0x00;

    WPUE = 0x00;
    WPUB = 0xFF;
    WPUA = 0xFC;
    WPUC = 0xC0;  // RX TX UART
    
    RA0PPS=0;
    RA1PPS=0;
    RA2PPS=0;

      // RxyI2C registers
   // RB1I2C = 0x00;
   // RB2I2C = 0x00;
   
    RB0PPS=0;
    RB1PPS=0;
    RB2PPS=0;
    RB3PPS=0;
    RB4PPS=0;
    RB5PPS=0;
    RB6PPS=0;
    RB7PPS=0;
   // RC3I2C = 0x00;
   // RC4I2C = 0x00;

   // ODx registers
    ODCONA = 0x07;  //  0x07 => open drain sur RA0,RA1,RA2  OWS sensor
    ODCONB = 0x00;
    ODCONC = 0x18;  // I2C 

   
  //  SLRCONx registers
    SLRCONA = 0xFF;
    SLRCONB = 0xFF; //0xFF;
    SLRCONC = 0xFF;

   // INLVLx registers
    INLVLA = 0xFF;
    INLVLB = 0xFF;
    INLVLC = 0xFF;
    INLVLE = 0x08;
    
    IOCAF=0;
    IOCAN=0;
    IOCAP=0;

    IOCBF=0;
    IOCBN=0;
    IOCBP=0;
    
    IOCCF=0;
    IOCCN=0;
    IOCCP=0;
    
    RC5PPS=0;  // SW6 input
           
	// I2C1
    RC3PPS = 0x21;      //RC3->I2C1:SCL1;    
    RC4PPS = 0x22;      //RC4->I2C1:SDA1; 
    // UART1
    RC6PPS = 0x13;      //RC6->UART1:TX1;    
    U1RXPPS = 0x17;     //RC7->UART1:RX1;    
    I2C1SCLPPS = 0x13;  //RC3->I2C1:SCL1;  
    I2C1SDAPPS = 0x14;  //RC4->I2C1:SDA1;     
}



void delay_X_ms(unsigned int n)
{
  unsigned int l=n;
    while (l--) 
    {__delay_ms(1);
    }
}

 
void main(void)
{
 
  
  OSCCON1 = 0x60;
  OSCCON3 = 0x00;
  OSCEN = 0x00;
  OSCFRQ = 0x08;  // 64Mhz
  OSCTUNE = 0x00;
  __delay_ms(100);
  
  Hardware_Init();
  
 // RC6PPS  = 0x13;                       // tx1 -> C6
 // U1RXPPS = 0x17;                       // rx1 <- C7
  U1BRGH  = BRG/256;
  U1BRGL = BRG%256;  // uart1, speed
  U1CON0  = 0xb0;                       // uart1, brgs=1, tx on, rx on
  U1CON1  = 0x80;                       // uart1 on
//U1CON2  = 0x00;  

    for (i=0;i<sizeof(TEXTE);i++) TEXTE[i]=0;
    for (i=0;i<sizeof(Buffer1);i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    txt=&TEXTE[0]; 
    CPrint(" Presentation :");  
    CRLF1();
        
    for (i=0;i<9;i++)   
    {
     CPrint(Messages[i]);  
    }
    CRLF1();
   
    CRLF1();
    sprintf(txt," Compile le %s a %s UTC\r\n avec version XC8 :  %d \r\n", __DATE__, __TIME__,__XC8_VERSION);
    Print(txt);
    CRLF1();
    __delay_xSec(2); CRLF1();
    
  
  
    SMT1_Init();  // 500Khz
    ST=(char *) &SMT1_Measure;
    SMT1_Measure=0L;
    SMT1STATbits.SMT1RST=1;
    SMT1CON1bits.SMT1GO=1;
    __delay_ms(100);
    SMT1CON1bits.SMT1GO=0;
    *(ST)=SMT1TMRL;
    *(ST+1)=SMT1TMRH;
    *(ST+2)=SMT1TMRU;
    *(ST+3)=0;
    L1=SMT1_Measure; 
    L2=L1<<1;    //  500Khz tick=2S => multiplie par 2   ,  31,25KHz L1>>5 par 32
    txt=&TEXTE[0];
    sprintf(txt," Test SMT1 avec delay 100mS , Nb Tics %lu L2=%lu uS\r\n",L1,L2);
   //  sprintf(txt," Test chrono SMT1 sur delay 100mS => %lu uS \r\n",L2);
    Print(txt);
    
    
      Interrupt_Init();
    PIE0bits.IOCIE=0;
    IOCEN=0;// invalide toutes interrup IOC
    IOCBP=0; //pas de detection front Montants sur PORTB 
    IOCBN=0x7E;  //detection front descendant (Negatif)  sauf RB7 et RB0
    IOCBF=0; // RAZ flag etat pins IOC PORTB
    PIR0bits.IOCIF=0;
    Drapeaux.Key_ON=0;  // raz flag detection interrupt INT0
    PIR1bits.INT0IF=0; // RAZ flag detection interrupt INT0
    PIE1bits.INT0IE=1;  // autorisee interrupt INT0 sur front descendant pin RB0
    GIE=1; // autorise Toutes les interruptions ( + dont l'UART RX !)
  

  WPUB    = 0x00;                       // pull-ups off
  IOCBP   = 0x00;                       // rising edge off
  IOCBN   = 0x7E;                       // falling edge B6,B5,B4,B3, B2, B1 sauf B0 et B7
  INT0EDG = 0;                          // falling edge int0 B0
  INT0IE  = 1;                          // int int0 B0 enabled
    
  for (i=0; i<6; i++) {                 // led start
   delay_X_ms(100); 
    LATA4 ^= 1;
  }
  
                    
  PrintChar(13); PrintChar(10);  delay_X_ms(200); 
  PrintChar(' ');PrintChar('O'); PrintChar('K');delay_X_ms(100); 
  PrintChar(13); PrintChar(10);  delay_X_ms(200); 
  Drapeaux.Key_ON=0;  
  INT0IF=0;
  GIE     = 1;  // int enabled
  while (1) 
  {
    LATA4 ^= 1;                         // led blink
  
    if(Drapeaux.Key_ON==1)
    {   i=0;
        CPrint(" Etats_BP : ");
        do
        {
           if ((Etats_BP & Poids[i])== Poids[i] ) CPrint(Switches[i]); 
           i++;
        } while(i<6); 
        L2=SMT1_Measure/500;
        sprintf(txt,"   =0X%02X  duree k=%5d  via SMT1 L2=%lu mS\r\n",Etats_BP,k,L2); // Duree_Appui);
        Print(txt);        
        Drapeaux.Key_ON=0;
     }
    

       RAZ_UART1_Buffer1(); // init et arme interrupt UART RX
        __delay_xSec(Delay_de_Boucle);    // sert de  delay de boucle principale   
       if(Flag_Buffer1==1)
       {
            CPrint("Recu :");
            Print(Buffer1);
            CRLF1();
         p0=&Buffer1[0];
         // cde BAVard
         if ((*(p0)=='B') && (*(p0+1)=='A') && ( *(p0+2)=='V') && ( *(p0+3)=='=') )
         {
             cx=*(p0+4) ;
            if  ( (cx >='0' ) &&  (cx<='9') ) Bavard=cx-48;	 
             p0=0;
         }   
	    
         p0=strncmp(Buffer1,"Reset",5);
         if (   ( p0>0) && (   strlen(p0)>=5)  )
         {  sprintf(CRam1,"\r\n Reset volontaire \r\n");
	       Print(CRam1);
	       p0=0;
	       __delay_xSec(4);
	        Reset();
	      }
	     p0=0;
         // autre tests ...
        } //if flag  
     
   }
}


/*
 * 
 *
 
 PIC18F27K42 + Test interrupt INT0 sur 6 BP portB
 Directory :C:\MPLABX_Projects\18F27K42_test_INT0_IOCBF_6BP_Uart1_2023-08
 Project :  Test_Paul
 Source :  main.c _2028-0821
 Config  Internal Fosc 64MHz
 Autres :  UART1_Functions.h et *.c 
 Eeprom : No 
 RA4=led,RA3=SQA,RC6=TX UART1 RC7=RX UART
 BP SW..SW5 -> OU  diodes-> RV0 INT0 , IOCBF 


 Compile le Aug 21 2023 a 09:49:44 UTC
 avec version XC8 :  2360 

 Test SMT1 avec delay 100mS , Nb Tics 49997 L2=99994 uS

 OK
 Etats_BP :  SW1    =0X02  duree k= 1443  via SMT1 L2=146 mS
 Etats_BP :  SW1    =0X02  duree k=  886  via SMT1 L2=89 mS
 Etats_BP :  SW0    =0X01  duree k= 3529  via SMT1 L2=357 mS
 Etats_BP :  SW2    =0X04  duree k= 2822  via SMT1 L2=285 mS
 Etats_BP :  SW3    =0X08  duree k= 3098  via SMT1 L2=313 mS
 Etats_BP :  SW4    =0X10  duree k=    0  via SMT1 L2=284 mS
 Etats_BP :  SW5    =0X20  duree k= 2398  via SMT1 L2=242 mS
 Etats_BP :  SW1  SW2    =0X06  duree k= 6560  via SMT1 L2=663 mS
 Etats_BP :  SW3    =0X08  duree k= 6713  via SMT1 L2=679 mS
 Etats_BP :  SW1  SW3    =0X0A  duree k= 4274  via SMT1 L2=432 mS
 Etats_BP :  SW2  SW3    =0X0C  duree k= 5074  via SMT1 L2=513 mS
 Etats_BP :  SW3    =0X08  duree k= 4860  via SMT1 L2=491 mS
 Etats_BP :  SW2  SW3    =0X0C  duree k= 4460  via SMT1 L2=451 mS

 * 
 * version original satinas (sans le bug sortie uart)
 * 
 OK
--------
-------1
------1-
-----1--
----1---
---1----
--1-----

 * */